unit LayerUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, cad, StdCtrls, ComCtrls, Buttons;

type
  TLayerFrm = class(TForm)
    Bevel2: TBevel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    PlayBtn: TBitBtn;
    CloseBtn: TBitBtn;
    StopBtn: TBitBtn;
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Timer1: TTimer;
    MyCAD1: TMyCAD;
    procedure PlayBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LayerFrm: TLayerFrm;
   VLayerID:integer;
implementation

{$R *.dfm}

procedure TLayerFrm.PlayBtnClick(Sender: TObject);
begin
  Timer1.Enabled:=true;
end;

procedure TLayerFrm.FormShow(Sender: TObject);
var

myBitmap:TBitmap;
i:integer;
istr:string;

begin

If MyCAD1.GetShapesCount  > 8 then Exit;

 {Create a temp bitmap to load form a disk file}
 MyBitmap := TBitmap.Create;

 for i:=0 to 7 do
 begin

      istr:=inttostr(i);

      {Load from files}
      Mybitmap.LoadFromFile( ExtractFilePath(Application.ExeName) +'images\'+istr+'.bmp');

      {a layer0 already exist by default}
      {Add Image into TMyCAD by code}
      MyCAD1.AddImageShapeByCode('MyImage'+istr,Point(10,10),MyBitmap);



      if i < 7 then MyCAD1.NewLayer('Layer'+inttostr(i+1 ), false);
 end;

 {free it because no use}
 MyBitmap.Free;


 {current layer id variables}
 VLayerID:=0;
 {do not show  a hot region}
 MyCAD1.DeSelectedAllShapesByCode;
end;

procedure TLayerFrm.Timer1Timer(Sender: TObject);
var
 i:integer;
begin
{Show the current layerID}
Edit1.Text:=  inttostr( VLayerID);

for i:=0 to 7 do
begin
   if i =  VLayerID  then
   {Let a layer visible}
   MyCAD1.VisibleLayerById(i)
   else
   {Let a layer hide}
   MyCAD1.InVisibleLayerByID(i);
end;

 {loop it}
 Inc(VLayerID);
 if VLayerID = 8 then  VLayerID:=0;

end;



procedure TLayerFrm.StopBtnClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
end;

procedure TLayerFrm.TrackBar1Change(Sender: TObject);

var
 i:integer;
begin

  Edit1.Text:=  inttostr( TrackBar1.Position);
  Timer1.Enabled:=false;
 for i:=0 to 7 do
begin
   if i =  TrackBar1.Position  then
   MyCAD1.VisibleLayerById(i)
   else
   MyCAD1.InVisibleLayerByID(i);
end;
end;


procedure TLayerFrm.CloseBtnClick(Sender: TObject);
begin
 Timer1.Enabled:= false;
 close;
end;

end.
