unit CADInspUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, InspCtrl, CompInsp,PropList, ExtCtrls,cad,TypInfo, ComCtrls;

type
  TCADInspFrm = class(TForm)
    Panel1: TPanel;
    CloseBtn: TButton;
    Panel2: TPanel;
    ComponentInspector1: TComponentInspector;
    ComponentComboBox1: TComponentComboBox;
   procedure ComponentInspector1SetValue(Sender: TObject; TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
    function ComponentInspector1CallEditor(Sender: TObject;
      TheIndex: Integer; var EnableDefault: Boolean): Boolean;
    procedure ComponentInspector1GetButtonType(Sender: TObject;
      TheIndex: Integer; var Value: TButtonType);
    procedure ComponentInspector1GetEnableExternalEditor(Sender: TObject;
      TheIndex: Integer; var Value: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ComponentInspector1GetName(Sender: TObject;
      TheIndex: Integer; var Value: String);
    procedure ComponentInspector1Filter(Sender: TObject; Prop: TProperty;
      var Result: Boolean);
   procedure ComponentInspector1GetValue(Sender: TObject;
     TheIndex: Integer; var Value: String);
    procedure ComponentComboBox1GetComponentText(Sender: TObject;
      AComponent: TComponent; var Text: String);
    procedure ComponentComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure BuildDict;
    function TranslatetoChinese(KeyName:String):string;
  end;

var
  CADInspFrm: TCADInspFrm;

Type
  DictRecord= record
     English:string;
     Chinese:string;
  end;


var
  EnglishChineseDict:Array[0..150] of DictRecord;


implementation

{$R *.dfm}
uses MainUnit;


procedure TCADInspFrm.ComponentInspector1SetValue(Sender: TObject;
  TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
begin

IF ComponentInspector1.Instance <> nil THEN
if Assigned(ComponentInspector1.Properties[TheIndex]) THEN
    IF ComponentInspector1.Properties[TheIndex].Name='Angle' THEN
     Value:= FloatToStr(StrToInt(Value)*pi/180);

 Mainfrm.MyCAD1.Invalidate
end;


function TCADInspFrm.ComponentInspector1CallEditor(Sender: TObject;   TheIndex: Integer; var EnableDefault: Boolean): Boolean;
var
  OldValue: string;
begin

 Result:=False;
  with ComponentInspector1 do
  begin
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
        if TypeKind in [tkString,tkWString,tkLString] then
        begin
          EnableDefault:=False;
          OldValue:=AsString;
          AsString:=InputBox(ComponentInspector1.Instance.Name,Name,OldValue);
          Result:=AsString<>OldValue;
          if Result then Mainfrm.MyCAD1.Invalidate
        end;


  end;

end;

procedure TCADInspFrm.ComponentInspector1GetButtonType(Sender: TObject;
  TheIndex: Integer; var Value: TButtonType);
begin

  with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
      if   (TypeKind in [tkString,tkWString,tkLString])and (Value=btNone) then
        Value:=btDialog;

end;

procedure TCADInspFrm.ComponentInspector1GetEnableExternalEditor(
  Sender: TObject; TheIndex: Integer; var Value: Boolean);
begin
 with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
    begin
      with Properties[TheIndex] do

        Value:=(TypeKind in [tkString,tkWString,tkLString]) or
        (PropType=TypeInfo(TColor) )  or IsType(TypeInfo(TGraphic))
        or IsType(TypeInfo(TUserData)) or IsType(TypeInfo(TStrings));

    end;

end;

procedure TCADInspFrm.FormActivate(Sender: TObject);
begin
   MainFrm.setInspector;
end;

procedure TCADInspFrm.CloseBtnClick(Sender: TObject);
begin
 close;
end;


procedure TCADInspFrm.ComponentInspector1GetName(Sender: TObject;
  TheIndex: Integer; var Value: String);
begin
//[sample]replace the property name in Inspector
//Like:
//if ComponentInspector1.Properties[TheIndex].Name='Name' then
//  value:='Property_Name';

  //if ComponentComboBox1.Instance is TMyShape then
  //begin
    value:='';
    value:=TranslatetoChinese(ComponentInspector1.Properties[TheIndex].Name);
  //end;
end;

procedure TCADInspFrm.ComponentInspector1Filter(Sender: TObject;
  Prop: TProperty; var Result: Boolean);
begin
//hide the some properties  in Inspector  that you do not showed
//like this:
//if  uppercase(Prop.Name)='NAME' then Result:=false;

end;


procedure TCADInspFrm.ComponentInspector1GetValue(Sender: TObject;
  TheIndex: Integer; var Value: String);
begin

IF ComponentInspector1.Instance <> nil THEN
   if Assigned(ComponentInspector1.Properties[TheIndex]) THEN
   BEGIN
       IF ComponentInspector1.Properties[TheIndex].Name='Angle' THEN
       try
          IF Value='' THEN Value:='0';
           Value:= IntToStr(Round(StrToFloat(Value)*180/pi));
       Except
         Value:='0';
       end;

       IF   ComponentInspector1.Properties[TheIndex].Name='UserData' THEN
          IF (ComponentInspector1.Properties[TheIndex].AsObject as TUserData).getcount =0 then
           Value:='(Empty)'
           else
        Value:='(Text)';
    END;

end;

procedure TCADInspFrm.ComponentComboBox1GetComponentText(Sender: TObject;
  AComponent: TComponent; var Text: String);
begin
//To Change the display text in ComponentCombobox
//like:
//if Text = 'Shape0: TMyRectangle' THEN Text:='Rectangle';
end;

procedure TCADInspFrm.ComponentComboBox1Change(Sender: TObject);
begin
With   ComponentComboBox1 do
begin
if Items.Objects[ItemIndex] is TMyShape then
begin
   MainFrm.MyCAD1.SelectShapeByCode(TMyShape(Items.Objects[ItemIndex]).GetShapeId);
end;
end;
end;

procedure TCADInspFrm.FormShow(Sender: TObject);
begin
MainFrm.setInspector;
end;

procedure TCADInspFrm.BuildDict;
begin
  
  EnglishChineseDict[1].English:='Angle';
  EnglishChineseDict[1].Chinese:='Ƕ';
  EnglishChineseDict[2].English:='Brush';
  EnglishChineseDict[2].Chinese:='ˢ';
  EnglishChineseDict[3].English:='Caption';
  EnglishChineseDict[3].Chinese:='';
  EnglishChineseDict[4].English:='CaptionShow';
  EnglishChineseDict[4].Chinese:='ʾ';
  EnglishChineseDict[5].English:='ColorBegin';
  EnglishChineseDict[5].Chinese:='ʼɫ';
  EnglishChineseDict[6].English:='ColorEnd';
  EnglishChineseDict[6].Chinese:='ɫ';
  EnglishChineseDict[7].English:='Font';
  EnglishChineseDict[7].Chinese:='';
  EnglishChineseDict[8].English:='GradientStyle';
  EnglishChineseDict[8].Chinese:='';
  EnglishChineseDict[9].English:='Info';
  EnglishChineseDict[9].Chinese:='Ϣ';
  EnglishChineseDict[10].English:='Locked';
  EnglishChineseDict[10].Chinese:='';
  EnglishChineseDict[11].English:='Name';
  EnglishChineseDict[11].Chinese:='';
  EnglishChineseDict[12].English:='Owner';
  EnglishChineseDict[12].Chinese:='';
  EnglishChineseDict[13].English:='Pen';
  EnglishChineseDict[13].Chinese:='';
  EnglishChineseDict[14].English:='Tag';
  EnglishChineseDict[14].Chinese:='ǩ';
  EnglishChineseDict[15].English:='UserData';
  EnglishChineseDict[15].Chinese:='Զ';
  EnglishChineseDict[16].English:='Color';
  EnglishChineseDict[16].Chinese:='ɫ';
  EnglishChineseDict[17].English:='Style';
  EnglishChineseDict[17].Chinese:='';
  EnglishChineseDict[18].English:='BkColor';
  EnglishChineseDict[18].Chinese:='Ӱɫ';
  EnglishChineseDict[19].English:='Charset';
  EnglishChineseDict[19].Chinese:='ַ';
  EnglishChineseDict[20].English:='Height';
  EnglishChineseDict[20].Chinese:='߶';
  EnglishChineseDict[21].English:='LogHeight';
  EnglishChineseDict[21].Chinese:='ַ߶';
  EnglishChineseDict[22].English:='LogWidth';
  EnglishChineseDict[22].Chinese:='ַ';
  EnglishChineseDict[23].English:='Pitch';
  EnglishChineseDict[23].Chinese:='б';
  EnglishChineseDict[24].English:='Size';
  EnglishChineseDict[24].Chinese:='С';
  EnglishChineseDict[25].English:='fsBold';
  EnglishChineseDict[25].Chinese:='Ӵ';
  EnglishChineseDict[26].English:='fsItalic';
  EnglishChineseDict[26].Chinese:='б';
  EnglishChineseDict[27].English:='fsUnderline';
  EnglishChineseDict[27].Chinese:='»';
  EnglishChineseDict[28].English:='fsStrikeOut';
  EnglishChineseDict[28].Chinese:='ɾ';
  EnglishChineseDict[29].English:='Mode';
  EnglishChineseDict[29].Chinese:='ģʽ';
  EnglishChineseDict[30].English:='Width';
  EnglishChineseDict[30].Chinese:='';
  EnglishChineseDict[31].English:='ArrowAngle';
  EnglishChineseDict[31].Chinese:='ͷǶ';
  EnglishChineseDict[32].English:='ArrowLength';
  EnglishChineseDict[32].Chinese:='ͷ';
  EnglishChineseDict[33].English:='ArrowOffset';
  EnglishChineseDict[33].Chinese:='ͷƫ';
  EnglishChineseDict[34].English:='ArrowStyle';
  EnglishChineseDict[34].Chinese:='ͷ';
  EnglishChineseDict[35].English:='ShowUserInfo';
  EnglishChineseDict[35].Chinese:='ʾûϢ';
  EnglishChineseDict[36].English:='TickStyle';
  EnglishChineseDict[36].Chinese:='';
  EnglishChineseDict[37].English:='LinkLineDrawStyle';
  EnglishChineseDict[37].Chinese:='';
  EnglishChineseDict[38].English:='ArcMode';
  EnglishChineseDict[38].Chinese:='Բģʽ';
  EnglishChineseDict[39].English:='ArcStyle';
  EnglishChineseDict[39].Chinese:='Բ';
  EnglishChineseDict[40].English:='IsBorder';
  EnglishChineseDict[40].Chinese:='߿';
  EnglishChineseDict[41].English:='IsSolid';
  EnglishChineseDict[41].Chinese:='ʵ';
  EnglishChineseDict[42].English:='Bitmap';
  EnglishChineseDict[42].Chinese:='ͼƬ';
  EnglishChineseDict[43].English:='Border';
  EnglishChineseDict[43].Chinese:='߿';
  EnglishChineseDict[44].English:='Transparent';
  EnglishChineseDict[44].Chinese:='͸';
  EnglishChineseDict[45].English:='BkBitmap';
  EnglishChineseDict[45].Chinese:='ͼƬ';
  EnglishChineseDict[46].English:='BkBitmapMode';
  EnglishChineseDict[46].Chinese:='ʾͼƬ';
  EnglishChineseDict[47].English:='Canvas';
  EnglishChineseDict[47].Chinese:='';
  EnglishChineseDict[48].English:='ColorOfBackGround';
  EnglishChineseDict[48].Chinese:='ɫ';
  EnglishChineseDict[49].English:='ColorOfHot';
  EnglishChineseDict[49].Chinese:='ѡɫ';
  EnglishChineseDict[50].English:='CrossLine';
  EnglishChineseDict[50].Chinese:='Խ';
  EnglishChineseDict[51].English:='Cursor';
  EnglishChineseDict[51].Chinese:='ͼ';
  EnglishChineseDict[52].English:='DragMode';
  EnglishChineseDict[52].Chinese:='϶ģʽ';
  EnglishChineseDict[53].English:='Enabled';
  EnglishChineseDict[53].Chinese:='Ч';
  EnglishChineseDict[54].English:='GridColor';
  EnglishChineseDict[54].Chinese:='ɫ';
  EnglishChineseDict[55].English:='GridHeight';
  EnglishChineseDict[55].Chinese:='߶';
  EnglishChineseDict[56].English:='GridPenSize';
  EnglishChineseDict[56].Chinese:='񻭱ʴС';
  EnglishChineseDict[57].English:='GridShow';
  EnglishChineseDict[57].Chinese:='ʾ';
  EnglishChineseDict[58].English:='GridType';
  EnglishChineseDict[58].Chinese:='';
  EnglishChineseDict[59].English:='GridWidth';
  EnglishChineseDict[59].Chinese:='';
  EnglishChineseDict[60].English:='HelpContext';
  EnglishChineseDict[60].Chinese:='';
  EnglishChineseDict[61].English:='HelpKeyword';
  EnglishChineseDict[61].Chinese:='ؼ';
  EnglishChineseDict[62].English:='HelpType';
  EnglishChineseDict[62].Chinese:='';
  EnglishChineseDict[63].English:='Hint';
  EnglishChineseDict[63].Chinese:='ʾ';
  EnglishChineseDict[64].English:='HotShow';
  EnglishChineseDict[64].Chinese:='ʾѡ';
  EnglishChineseDict[65].English:='HotSize';
  EnglishChineseDict[65].Chinese:='ʾС';
  EnglishChineseDict[66].English:='LabelValue';
  EnglishChineseDict[66].Chinese:='С';
  EnglishChineseDict[67].English:='LabelXY';
  EnglishChineseDict[67].Chinese:='';
  EnglishChineseDict[68].English:='Left';
  EnglishChineseDict[68].Chinese:='߾';
  EnglishChineseDict[69].English:='OperateAllLayer';
  EnglishChineseDict[69].Chinese:='ͼ';
  EnglishChineseDict[70].English:='CopyMode';
  EnglishChineseDict[70].Chinese:='ģʽֵ';
  EnglishChineseDict[71].English:='PageFoot';
  EnglishChineseDict[71].Chinese:='ҳ';
  EnglishChineseDict[72].English:='PageFootAlignment';
  EnglishChineseDict[72].Chinese:='ҳзʽ';
  EnglishChineseDict[73].English:='PageFootFont';
  EnglishChineseDict[73].Chinese:='ҳ';
  EnglishChineseDict[74].English:='PageFootToBottom';
  EnglishChineseDict[74].Chinese:='ҳű߾';
  EnglishChineseDict[75].English:='PageHead';
  EnglishChineseDict[75].Chinese:='ҳü';
  EnglishChineseDict[76].English:='PageHeadAlignment';
  EnglishChineseDict[76].Chinese:='ҳüзʽ';
  EnglishChineseDict[77].English:='PageHeadFont';
  EnglishChineseDict[77].Chinese:='ҳü';
  EnglishChineseDict[78].English:='PageHeadToTop';
  EnglishChineseDict[78].Chinese:='ҳü߾';
  EnglishChineseDict[79].English:='PageHeight';
  EnglishChineseDict[79].Chinese:='ҳ߶';
  EnglishChineseDict[80].English:='PageOrientation';
  EnglishChineseDict[80].Chinese:='ҳ淽';
  EnglishChineseDict[81].English:='PageStyle';
  EnglishChineseDict[81].Chinese:='ҳС';
  EnglishChineseDict[82].English:='PageWidth';
  EnglishChineseDict[82].Chinese:='ҳ';
  EnglishChineseDict[83].English:='PrintABorder';
  EnglishChineseDict[83].Chinese:='ӡ߿';
  EnglishChineseDict[84].English:='PrintABordertoBottom';
  EnglishChineseDict[84].Chinese:='ӡ߿±߾';
  EnglishChineseDict[85].English:='PrintABordertoLeft';
  EnglishChineseDict[85].Chinese:='ӡ߿߾';
  EnglishChineseDict[86].English:='PrintABordertoRight';
  EnglishChineseDict[86].Chinese:='ӡ߿ұ߾';
  EnglishChineseDict[87].English:='PrintABordertoTop';
  EnglishChineseDict[87].Chinese:='ӡ߿ϱ߾';
  EnglishChineseDict[88].English:='PrintBackground';
  EnglishChineseDict[88].Chinese:='ӡ';
  EnglishChineseDict[89].English:='Ratio';
  EnglishChineseDict[89].Chinese:='ͼƬ';
  EnglishChineseDict[90].English:='ResizeEnable';
  EnglishChineseDict[90].Chinese:='Ƿ';
  EnglishChineseDict[91].English:='ReturnToSelecting';
  EnglishChineseDict[91].Chinese:='ѡģʽ';
  EnglishChineseDict[92].English:='RotateEnable';
  EnglishChineseDict[92].Chinese:='Ƿת';
  EnglishChineseDict[93].English:='ShapeTool';
  EnglishChineseDict[93].Chinese:='ͼ';
  EnglishChineseDict[94].English:='ShowHint';
  EnglishChineseDict[94].Chinese:='ʾʾ';
  EnglishChineseDict[95].English:='ShowHotLink';
  EnglishChineseDict[95].Chinese:='ʾӵ';
  EnglishChineseDict[96].English:='Snap';
  EnglishChineseDict[96].Chinese:='뵽';
  EnglishChineseDict[97].English:='SnapPixels';
  EnglishChineseDict[97].Chinese:='';
  EnglishChineseDict[98].English:='SnapShape';
  EnglishChineseDict[98].Chinese:='뵽ͼ';
  EnglishChineseDict[99].English:='TheUNIT';
  EnglishChineseDict[99].Chinese:='λ';
  EnglishChineseDict[100].English:='Top';
  EnglishChineseDict[100].Chinese:='ϱ߾';
  EnglishChineseDict[101].English:='UndoRedoSize';
  EnglishChineseDict[101].Chinese:='۴С';
  EnglishChineseDict[102].English:='Visible';
  EnglishChineseDict[102].Chinese:='ɼ';
  EnglishChineseDict[103].English:='XYMode';
  EnglishChineseDict[103].Chinese:='ϵ';
  EnglishChineseDict[104].English:='Zoom';
  EnglishChineseDict[104].Chinese:='ű';
  EnglishChineseDict[105].English:='GridOperation';
  EnglishChineseDict[105].Chinese:='';
  EnglishChineseDict[106].English:='IsFlipVert';
  EnglishChineseDict[106].Chinese:='ֱת';
  EnglishChineseDict[107].English:='IsFlipHorz';
  EnglishChineseDict[107].Chinese:='ˮƽת';
  EnglishChineseDict[108].English:='HAlignment';
  EnglishChineseDict[108].Chinese:='ˮƽ';
  EnglishChineseDict[109].English:='VAlignment';
  EnglishChineseDict[109].Chinese:='ֱ';
  EnglishChineseDict[110].English:='Lines';
  EnglishChineseDict[110].Chinese:='ı';
  EnglishChineseDict[111].English:='WordWrap';
  EnglishChineseDict[111].Chinese:='Զ';
  //add at here
    EnglishChineseDict[112].English:='LinklineAroundShape';
  EnglishChineseDict[112].Chinese:='ӻ';
   EnglishChineseDict[113].English:='RotateConstraintDegree';
  EnglishChineseDict[113].Chinese:='ת';
  EnglishChineseDict[114].English:='MouseEffect';
  EnglishChineseDict[114].Chinese:='Զ';
  EnglishChineseDict[115].English:='MultiInfo';
  EnglishChineseDict[115].Chinese:='Ϣ';
  EnglishChineseDict[116].English:='MultiInfoAlignment';
  EnglishChineseDict[116].Chinese:='Ϣˮƽ';
  EnglishChineseDict[117].English:='LockBound';
  EnglishChineseDict[117].Chinese:='ͼڱ߿';
  EnglishChineseDict[118].English:='AssociateSideResizing';
  EnglishChineseDict[118].Chinese:='߿';
end;

function TCADInspFrm.TranslatetoChinese(KeyName: String): string;
var
  i:integer;
begin
  Result:='';
  for i:=0 to 150 do
  if EnglishChineseDict[i].English=KeyName then
  BEGIN
     Result:= EnglishChineseDict[i].Chinese;
     Break;
  END;
end;

procedure TCADInspFrm.FormCreate(Sender: TObject);
begin
  BuildDict;
end;

end.
