unit layerUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ImgList, Buttons, StdCtrls, ExtCtrls;

type
  TLayerFrm = class(TForm)
    LayerImage: TImageList;
    LayerTreeView: TTreeView;
    Panel1: TPanel;
    DeleteLayerBtn: TSpeedButton;
    NewLayerBtn: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure LayerTreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure LayerTreeViewAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure DeleteLayerBtnClick(Sender: TObject);
    procedure NewLayerBtnClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
    

  public
   procedure Refreshit;
  end;

var
  LayerFrm: TLayerFrm;

implementation

uses MainUnit;

{$R *.dfm}

procedure TLayerFrm.FormShow(Sender: TObject);
begin
 Refreshit;
end;

procedure TLayerFrm.LayerTreeViewEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
begin
if s='' then s:=Node.Text;
MainFrm.MyCAD1.SetLayerNameByName(s,Node.Text);
end;

procedure TLayerFrm.LayerTreeViewAdvancedCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);
begin
if cdsSelected	in state then
Begin
With MainFrm.MyCAD1 do
 CurrentLayerId:= GetLayerIdByNo( Node.Index);

end;
end;

procedure TLayerFrm.DeleteLayerBtnClick(Sender: TObject);

var
  id: integer;
begin
Screen.Cursor:=     crHourGlass;
  if LayerTreeView.Selected.Index > -1 then
  begin
    Id := MainFrm.MyCAD1.GetLayerIdByNo(LayerTreeView.Selected.Index);
    MainFrm.MyCAD1.DeleteLayerByID(id);
    Refreshit;
  end;
Screen.Cursor:=     crDefault;  
end;

procedure TLayerFrm.NewLayerBtnClick(Sender: TObject);
begin
With MainFrm.MyCAD1 do
 NewLayer('Layer' + inttostr(GetMaxLayerId + 1));
 Refreshit;
end;

procedure TLayerFrm.SpeedButton3Click(Sender: TObject);
var
 id:integer;
begin
 With MainFrm.MyCAD1  do
 Begin
  id:= GetLayerIdByNo(LayerTreeView.Selected.Index);
  if id > -1 then
  Begin
    if IsVisibleLayerByID(id) then
      InVisibleLayerById(id)
    else
      VisibleLayerById(id);
    Refreshit;
  end;
 end;
end;


procedure TLayerFrm.Refreshit;
Var
 i,id:integer;
 SelectedNode,ANode:TTreeNode;

begin
 LayerTreeView.Items.Clear;
 with  MainFrm.MyCAD1 do
 Begin
  for i := 0 to MainFrm.MyCAD1.GetLayersCount - 1 do
  begin
    Id := MainFrm.MyCAD1.GetLayerIdByNo(i);
    if Id > -1 then
    begin

    ANode := LayerTreeView.Items.Add(nil, GetLayerNameByID(id));

    if MainFrm.MyCAD1.IsVisibleLayerByID(Id) then
    begin
      ANode.ImageIndex:=0;
      ANode.SelectedIndex:=0;
      end
      else
      Begin
       ANode.ImageIndex:=1;
     ANode.SelectedIndex:=1;
      end;
      if CurrentLayerId = id then
      begin
       SelectedNode:= ANode;
       LayerTreeView.Selected := SelectedNode;
      end;
    end;
  end;
  end;

end;
procedure TLayerFrm.SpeedButton1Click(Sender: TObject);
begin
 Close;
end;

procedure TLayerFrm.SpeedButton2Click(Sender: TObject);
begin
Refreshit
end;

end.
