unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, cad;

type
  TMainForm = class(TForm)
    MyCAD1: TMyCAD;
    btnDrawRectangle: TButton;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    procedure btnDrawRectangleClick(Sender: TObject);
    procedure MyCAD1ShapeMouseResizing(AShape: TMyShape; FromPoint: TPoint;
      var ToPoint: TPoint);
    procedure MyCAD1ShapeMouseResized(AShape: TMyShape; FromPoint: TPoint;
      var ToPoint: TPoint);
    procedure MyCAD1ShapeAdded(var AShape: TMyShape; ShapeCount: Integer);
    procedure MyCAD1ShapeSelected(LastSelectedShape,
      SelectedShape: TMyShape);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

  // TCAD Boundry
  md,wd:TPoint;
  shape:TMyShape;
  ff:boolean;

implementation

{$R *.dfm}

procedure TMainForm.btnDrawRectangleClick(Sender: TObject);
begin
  MyCAD1.ShapeTool:=spRectangle;
end;

procedure TMainForm.MyCAD1ShapeMouseResizing(AShape: TMyShape;
  FromPoint: TPoint; var ToPoint: TPoint);
begin
  if (AShape.SelectedHotId = 0) or (AShape.SelectedHotId = 2) then
  begin
    toPoint.X := toPoint.X;
    ToPoint.Y := fromPoint.Y + round((ToPoint.X - fromPoint.X) / 2);
  end
  else if (AShape.SelectedHotId = 1) or (AShape.SelectedHotId = 3) then
  begin
    toPoint.X := toPoint.X;
    ToPoint.Y := fromPoint.Y - round((ToPoint.X - fromPoint.X) / 2);
  end
  else
  begin
    toPoint.Y := fromPoint.Y
  end;
end;

procedure TMainForm.MyCAD1ShapeMouseResized(AShape: TMyShape;
  FromPoint: TPoint; var ToPoint: TPoint);
begin
  if (AShape.SelectedHotId = 0) or (AShape.SelectedHotId = 2) then
  begin
    toPoint.X := toPoint.X;
    ToPoint.Y := fromPoint.Y + round((ToPoint.X - fromPoint.X) / 2);
  end
  else if (AShape.SelectedHotId = 1) or (AShape.SelectedHotId = 3) then
  begin
    toPoint.X := toPoint.X;
    ToPoint.Y := fromPoint.Y - round((ToPoint.X - fromPoint.X) / 2);
  end
  else
  begin
    toPoint.Y := fromPoint.Y;
  end;
end;

procedure TMainForm.MyCAD1ShapeAdded(var AShape: TMyShape;
  ShapeCount: Integer);
begin

  if CheckBox1.Checked then
    (AShape as TMyRectangle).AssociateSideResizing := true
  else
    (AShape as TMyRectangle).AssociateSideResizing := false;
end;

procedure TMainForm.MyCAD1ShapeSelected(LastSelectedShape,
  SelectedShape: TMyShape);
begin
  CheckBox1.Checked := (MyCAD1.GetSelectedShape as TMyRectangle).AssociateSideResizing;
end;

end.
