unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cad, StdCtrls, ExtCtrls, ComCtrls, jpeg, Buttons,ShellAPI;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    MyCAD1: TMyCAD;
    MyCAD2: TMyCAD;
    OnBtn: TButton;
    Offbtn: TButton;
    BlinkBtn: TButton;
    Panel2: TPanel;
    Image2: TImage;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure OnBtnClick(Sender: TObject);
    procedure OffbtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BlinkBtnClick(Sender: TObject);
    procedure MyCAD2ShapeSelected(LastSelectedShape,
      SelectedShape: TMyShape);
    procedure MyCAD2ShapeMouseDragging(AShape: TMyShape; FromPoint: TPoint;
      var ToPoint: TPoint);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  State:integer;
implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var
  ATxt:string;
  dy1,dy2:single;
begin
 if MyCAD1.GetShapeByName('RectangleShape') = nil then
 Begin

  MyCAD1.AddShapeByCode(MyCAD1,spRectangle, 'RectangleShape', [MyPoint(90, 111),
    MyPoint(280, 111), MyPoint(280, 220), MyPoint(90, 220)], 0);
    MyCAD1.Repaint;
  end;


  if MyCAD2.GetShapeByName('cuvetteShape1') = nil then
  Begin
    MyCAD2.AddShapeByCode(MyCAD2,spRectangle, 'cuvetteShape1', [MyPoint(90, 111),
      MyPoint(120, 111), MyPoint(120, 220), MyPoint(90, 220)], 0);

  end;

  if MyCAD2.GetShapeByName('cuvetteShape2') = nil then
  Begin
    MyCAD2.AddShapeByCode(MyCAD2,spRectangle, 'cuvetteShape2', [MyPoint(90, 150),
       MyPoint(120, 150), MyPoint(120, 220), MyPoint(90, 220)], 0);
    with  MyCAD2.GetShapeByName('cuvetteShape2') do
     begin
        Brush.Style:=bsClear;
        ColorBegin:=clRed;
        ColorEnd:=clBlack;
        GradientStyle:=gsLinearH;
     end;

  end;


   if MyCAD2.GetShapeByName('arrowShape2') = nil then
  Begin

    MyCAD2.AddShapeByCode(MyCAD2,spPolygon, 'arrowShape2', [ MyPoint(120, 150), MyPoint(130, 140), MyPoint(130, 160)], 0);
    with  MyCAD2.GetShapeByName('arrowShape2') do
     begin
        Brush.Style:=bsClear;
        ColorBegin:=clWhite;
        ColorEnd:=clBlack;
        GradientStyle:=gsLinearH;
     end;

  end;

   if MyCAD2.GetShapeByName('TextShape') = nil then
  Begin


   MyCAD2.AddShapeByCode(MyCAD2,spText, 'TextShape', [MyPoint(100, 150), MyPoint(110, 150),
    MyPoint(110, 160), MyPoint(100, 160)],0, '30%');

    dy2:=MyCAD2.GetShapeByName('cuvetteShape2').GetPoint(3).y -   MyCAD2.GetShapeByName('cuvetteShape2').GetPoint(0).y;
    dy1:=MyCAD2.GetShapeByName('cuvetteShape1').GetPoint(3).y -   MyCAD2.GetShapeByName('cuvetteShape1').GetPoint(0).y;
   ATxt:=   FloatToStrF( 100*(dy2/dy1),ffNumber,2,0)+'%';

     with  MyCAD2.GetShapeByName('TextShape') do
     begin
        info:=  ATxt;
        Font.Name:='Arial';
        Font.Style:= [ fsBold];
        Font.Color:=clYellow;
     end;

  end;

  MyCAD2.Repaint;

end;


procedure TForm1.OnBtnClick(Sender: TObject);
Var
  AShape:TMyShape;
begin
  AShape:=MyCAD1.GetShapeByName('RectangleShape');
      Timer1.Enabled:=false;
   if AShape <> nil then
   begin
    AShape.Brush.Color:=clRed;
    AShape.Brush.Style:=bsSolid;
    MyCAD1.Repaint;
    State:=1;
   end;

end;

procedure TForm1.OffbtnClick(Sender: TObject);


Var
  AShape:TMyShape;
begin
  AShape:=MyCAD1.GetShapeByName('RectangleShape');
   Timer1.Enabled:=false;
   if AShape <> nil then
   begin
      AShape.Brush.Style:=bsClear;
      MyCAD1.Repaint;
      State:=0;
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var
  AShape:TMyShape;
begin
       if State=1 then
         begin

            AShape:=MyCAD1.GetShapeByName('RectangleShape');

            if AShape <> nil then
           begin
                AShape.Brush.Style:=bsClear;
                MyCAD1.Repaint;
                State:=0;
            end;
        end

        else
         begin
              AShape:=MyCAD1.GetShapeByName('RectangleShape');

   if AShape <> nil then
   begin
    AShape.Brush.Color:=clRed;
    AShape.Brush.Style:=bsSolid;
    MyCAD1.Repaint;
    State:=1;
   end;

         end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  State:=0;
end;

procedure TForm1.BlinkBtnClick(Sender: TObject);
begin
    Timer1.Enabled:=true;
end;

procedure TForm1.MyCAD2ShapeSelected(LastSelectedShape,
  SelectedShape: TMyShape);
begin
  if SelectedShape= MyCAD2.GetShapeByName('arrowShape2')  then
  begin
     MyCAD2.DragMode:= dgVert;
  end
  else
     MyCAD2.DragMode:= dgBoth;

end;

procedure TForm1.MyCAD2ShapeMouseDragging(AShape: TMyShape;
  FromPoint: TPoint; var ToPoint: TPoint);
var

   cuvetteShape2,TextShape:TMyShape;
   APoint:TMyPoint;
   ATxt:string;
    dy1,dy2:single;
    movey:single;
    movex:single;
begin
    if  AShape =  MyCAD2.GetShapeByName('arrowShape2') then
     begin


     cuvetteShape2:=  MyCAD2.GetShapeByName('cuvetteShape2');
     APoint:=  cuvetteShape2.GetPoint(0);
     cuvetteShape2.SetPointInZoom(0,MyPoint(APoint.x,ToPoint.y));

     movey:=  cuvetteShape2.GetPoint(0).y - APoint.Y;
     APoint:=  cuvetteShape2.GetPoint(1);
      cuvetteShape2.SetPointInZoom(1,MyPoint(APoint.x,ToPoint.y));



     dy2:=MyCAD2.GetShapeByName('cuvetteShape2').GetPoint(3).y -   MyCAD2.GetShapeByName('cuvetteShape2').GetPoint(0).y;
     dy1:=MyCAD2.GetShapeByName('cuvetteShape1').GetPoint(3).y -   MyCAD2.GetShapeByName('cuvetteShape1').GetPoint(0).y;
     ATxt:=   FloatToStrF( 100*(dy2/dy1),ffNumber,2,0)+'%';


       TextShape:=MyCAD2.GetShapeByName('TextShape');
        TextShape.info:=  ATxt;
       movex:=0;
      MyCAD2.Move(TextShape,movex, movey);




      MyCAD2.Repaint;
     end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
shellexecute(0,'open',pChar(edit1.text),nil,nil,sw_shownormal);

end;

end.



